diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wifi/model/he/multi-user-scheduler.cc ns-3.38/src/wifi/model/he/multi-user-scheduler.cc
--- ns-3.37/src/wifi/model/he/multi-user-scheduler.cc	2022-11-01 17:37:24.743395800 -0700
+++ ns-3.38/src/wifi/model/he/multi-user-scheduler.cc	2023-03-16 20:54:23.856869200 -0700
@@ -92,11 +92,8 @@
 {
     NS_LOG_FUNCTION(this);
     m_apMac = nullptr;
-    m_heFem = nullptr;
     m_edca = nullptr;
-    m_dlInfo.psduMap.clear();
-    m_dlInfo.txParams.Clear();
-    m_ulInfo.txParams.Clear();
+    m_lastTxInfo.clear();
     m_accessReqTimer.Cancel();
     Object::DoDispose();
 }
@@ -131,6 +128,19 @@
 }
 
 void
+MultiUserScheduler::SetAccessReqInterval(Time interval)
+{
+    NS_LOG_FUNCTION(this << interval.As(Time::MS));
+    m_accessReqInterval = interval;
+    // start the timer if past initialization
+    if (m_accessReqInterval.IsStrictlyPositive() && IsInitialized())
+    {
+        m_accessReqTimer =
+            Simulator::Schedule(m_accessReqInterval, &MultiUserScheduler::AccessReqTimeout, this);
+    }
+}
+
+void
 MultiUserScheduler::SetWifiMac(Ptr<ApWifiMac> mac)
 {
     NS_LOG_FUNCTION(this << mac);
@@ -141,14 +151,24 @@
     NS_ABORT_MSG_IF(!m_apMac || !m_apMac->GetHeConfiguration(),
                     "MultiUserScheduler can only be installed on HE APs");
 
-    m_heFem = DynamicCast<HeFrameExchangeManager>(m_apMac->GetFrameExchangeManager());
-    m_heFem->SetMultiUserScheduler(this);
+    for (uint8_t linkId = 0; linkId < m_apMac->GetNLinks(); linkId++)
+    {
+        auto heFem = DynamicCast<HeFrameExchangeManager>(m_apMac->GetFrameExchangeManager(linkId));
+        NS_ASSERT(heFem);
+        heFem->SetMultiUserScheduler(this);
+    }
 }
 
 Ptr<WifiRemoteStationManager>
-MultiUserScheduler::GetWifiRemoteStationManager() const
+MultiUserScheduler::GetWifiRemoteStationManager(uint8_t linkId) const
+{
+    return m_apMac->GetWifiRemoteStationManager(linkId);
+}
+
+Ptr<HeFrameExchangeManager>
+MultiUserScheduler::GetHeFem(uint8_t linkId) const
 {
-    return m_apMac->GetWifiRemoteStationManager();
+    return StaticCast<HeFrameExchangeManager>(m_apMac->GetFrameExchangeManager(linkId));
 }
 
 void
@@ -159,92 +179,108 @@
     // request channel access if not requested yet
     auto edca = m_apMac->GetQosTxop(m_accessReqAc);
 
-    if (edca->GetAccessStatus(SINGLE_LINK_OP_ID) == Txop::NOT_REQUESTED)
+    for (uint8_t linkId = 0; linkId < m_apMac->GetNLinks(); linkId++)
     {
-        m_apMac->GetChannelAccessManager()->RequestAccess(edca);
+        if (edca->GetAccessStatus(linkId) == Txop::NOT_REQUESTED)
+        {
+            m_apMac->GetChannelAccessManager(linkId)->RequestAccess(edca);
+        }
     }
 
     // restart timer
-    m_accessReqTimer =
-        Simulator::Schedule(m_accessReqInterval, &MultiUserScheduler::AccessReqTimeout, this);
+    if (m_accessReqInterval.IsStrictlyPositive())
+    {
+        m_accessReqTimer =
+            Simulator::Schedule(m_accessReqInterval, &MultiUserScheduler::AccessReqTimeout, this);
+    }
 }
 
 MultiUserScheduler::TxFormat
 MultiUserScheduler::NotifyAccessGranted(Ptr<QosTxop> edca,
                                         Time availableTime,
                                         bool initialFrame,
-                                        uint16_t allowedWidth)
+                                        uint16_t allowedWidth,
+                                        uint8_t linkId)
 {
-    NS_LOG_FUNCTION(this << edca << availableTime << initialFrame << allowedWidth);
+    NS_LOG_FUNCTION(this << edca << availableTime << initialFrame << allowedWidth << linkId);
 
     m_edca = edca;
     m_availableTime = availableTime;
     m_initialFrame = initialFrame;
     m_allowedWidth = allowedWidth;
+    m_linkId = linkId;
 
     if (m_accessReqTimer.IsRunning() && m_restartTimerUponAccess)
     {
         // restart access timer
         m_accessReqTimer.Cancel();
-        m_accessReqTimer =
-            Simulator::Schedule(m_accessReqInterval, &MultiUserScheduler::AccessReqTimeout, this);
+        if (m_accessReqInterval.IsStrictlyPositive())
+        {
+            m_accessReqTimer = Simulator::Schedule(m_accessReqInterval,
+                                                   &MultiUserScheduler::AccessReqTimeout,
+                                                   this);
+        }
     }
 
     TxFormat txFormat = SelectTxFormat();
 
     if (txFormat == DL_MU_TX)
     {
-        m_dlInfo = ComputeDlMuInfo();
+        m_lastTxInfo[linkId].dlInfo = ComputeDlMuInfo();
     }
     else if (txFormat == UL_MU_TX)
     {
-        NS_ABORT_MSG_IF(!m_heFem, "UL MU PPDUs are only supported by HE APs");
-        m_ulInfo = ComputeUlMuInfo();
+        m_lastTxInfo[linkId].ulInfo = ComputeUlMuInfo();
         CheckTriggerFrame();
     }
 
     if (txFormat != NO_TX)
     {
-        m_lastTxFormat = txFormat;
+        m_lastTxInfo[linkId].lastTxFormat = txFormat;
     }
     return txFormat;
 }
 
 MultiUserScheduler::TxFormat
-MultiUserScheduler::GetLastTxFormat() const
+MultiUserScheduler::GetLastTxFormat(uint8_t linkId)
 {
-    return m_lastTxFormat;
+    return m_lastTxInfo[linkId].lastTxFormat;
 }
 
 MultiUserScheduler::DlMuInfo&
-MultiUserScheduler::GetDlMuInfo()
+MultiUserScheduler::GetDlMuInfo(uint8_t linkId)
 {
-    NS_ABORT_MSG_IF(m_lastTxFormat != DL_MU_TX, "Next transmission is not DL MU");
+    NS_ABORT_MSG_IF(m_lastTxInfo[linkId].lastTxFormat != DL_MU_TX,
+                    "Next transmission is not DL MU");
 
 #ifdef NS3_BUILD_PROFILE_DEBUG
     // check that all the addressed stations support HE
-    for (auto& psdu : m_dlInfo.psduMap)
+    for (auto& psdu : m_lastTxInfo[linkId].dlInfo.psduMap)
     {
-        NS_ABORT_MSG_IF(!GetWifiRemoteStationManager()->GetHeSupported(psdu.second->GetAddr1()),
+        auto receiver = psdu.second->GetAddr1();
+        auto linkId = m_apMac->IsAssociated(receiver);
+        NS_ABORT_MSG_IF(!linkId, "Station " << receiver << " should be associated");
+        NS_ABORT_MSG_IF(!GetWifiRemoteStationManager(*linkId)->GetHeSupported(receiver),
                         "Station " << psdu.second->GetAddr1() << " does not support HE");
     }
 #endif
 
-    return m_dlInfo;
+    return m_lastTxInfo[linkId].dlInfo;
 }
 
 MultiUserScheduler::UlMuInfo&
-MultiUserScheduler::GetUlMuInfo()
+MultiUserScheduler::GetUlMuInfo(uint8_t linkId)
 {
-    NS_ABORT_MSG_IF(m_lastTxFormat != UL_MU_TX, "Next transmission is not UL MU");
+    NS_ABORT_MSG_IF(m_lastTxInfo[linkId].lastTxFormat != UL_MU_TX,
+                    "Next transmission is not UL MU");
 
-    return m_ulInfo;
+    return m_lastTxInfo[linkId].ulInfo;
 }
 
 Ptr<WifiMpdu>
-MultiUserScheduler::GetTriggerFrame(const CtrlTriggerHeader& trigger) const
+MultiUserScheduler::GetTriggerFrame(const CtrlTriggerHeader& trigger, uint8_t linkId) const
 {
-    NS_LOG_FUNCTION(this);
+    NS_LOG_FUNCTION(this << linkId);
 
     Ptr<Packet> packet = Create<Packet>();
     packet->AddHeader(trigger);
@@ -253,14 +289,14 @@
     if (trigger.GetNUserInfoFields() == 1)
     {
         auto aid = trigger.begin()->GetAid12();
-        auto aidAddrMapIt = m_apMac->GetStaList().find(aid);
-        NS_ASSERT(aidAddrMapIt != m_apMac->GetStaList().end());
+        auto aidAddrMapIt = m_apMac->GetStaList(linkId).find(aid);
+        NS_ASSERT(aidAddrMapIt != m_apMac->GetStaList(linkId).end());
         receiver = aidAddrMapIt->second;
     }
 
     WifiMacHeader hdr(WIFI_MAC_CTL_TRIGGER);
     hdr.SetAddr1(receiver);
-    hdr.SetAddr2(m_apMac->GetAddress());
+    hdr.SetAddr2(GetHeFem(linkId)->GetAddress());
     hdr.SetDsNotTo();
     hdr.SetDsNotFrom();
 
@@ -274,9 +310,10 @@
 
     // Set the CS Required subfield to true, unless the UL Length subfield is less
     // than or equal to 76 (see Section 26.5.2.5 of 802.11ax-2021)
-    m_ulInfo.trigger.SetCsRequired(m_ulInfo.trigger.GetUlLength() > 76);
+    m_lastTxInfo[m_linkId].ulInfo.trigger.SetCsRequired(
+        m_lastTxInfo[m_linkId].ulInfo.trigger.GetUlLength() > 76);
 
-    m_heFem->SetTargetRssi(m_ulInfo.trigger);
+    GetHeFem(m_linkId)->SetTargetRssi(m_lastTxInfo[m_linkId].ulInfo.trigger);
 }
 
 uint32_t
@@ -287,12 +324,13 @@
     uint8_t maxNTids = 0;
     for (const auto& userInfo : trigger)
     {
-        const auto staIt = m_apMac->GetStaList().find(userInfo.GetAid12());
-        NS_ASSERT(staIt != m_apMac->GetStaList().cend());
+        auto address = m_apMac->GetMldOrLinkAddressByAid(userInfo.GetAid12());
+        NS_ASSERT_MSG(address, "AID " << userInfo.GetAid12() << " not found");
+
         uint8_t staNTids = 0;
         for (uint8_t tid = 0; tid < 8; tid++)
         {
-            if (m_heFem->GetBaAgreementEstablished(staIt->second, tid))
+            if (m_apMac->GetBaAgreementEstablishedAsRecipient(*address, tid))
             {
                 staNTids++;
             }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wifi/model/he/multi-user-scheduler.h ns-3.38/src/wifi/model/he/multi-user-scheduler.h
--- ns-3.37/src/wifi/model/he/multi-user-scheduler.h	2022-11-01 17:37:24.743395800 -0700
+++ ns-3.38/src/wifi/model/he/multi-user-scheduler.h	2023-03-16 20:54:23.856869200 -0700
@@ -94,52 +94,76 @@
      *                     of the TXOP. This is used to determine whether the TXOP
      *                     limit can be exceeded
      * \param allowedWidth the allowed width in MHz for the next transmission
+     * \param linkId the ID of the link over which channel access was gained
      * \return the format of the next transmission
      */
     TxFormat NotifyAccessGranted(Ptr<QosTxop> edca,
                                  Time availableTime,
                                  bool initialFrame,
-                                 uint16_t allowedWidth);
+                                 uint16_t allowedWidth,
+                                 uint8_t linkId);
 
     /**
-     * Get the information required to perform a DL MU transmission. Note
-     * that this method can only be called if GetTxFormat returns DL_MU_TX.
+     * Get the information required to perform a DL MU transmission on the given link. Note
+     * that this method can only be called if GetTxFormat returns DL_MU_TX on the given link.
      *
+     * \param linkId the ID of the given link
      * \return the information required to perform a DL MU transmission
      */
-    DlMuInfo& GetDlMuInfo();
+    DlMuInfo& GetDlMuInfo(uint8_t linkId);
 
     /**
-     * Get the information required to solicit an UL MU transmission. Note
-     * that this method can only be called if GetTxFormat returns UL_MU_TX.
+     * Get the information required to solicit an UL MU transmission on the given link. Note
+     * that this method can only be called if GetTxFormat returns UL_MU_TX on the given link.
      *
+     * \param linkId the ID of the given link
      * \return the information required to solicit an UL MU transmission
      */
-    UlMuInfo& GetUlMuInfo();
+    UlMuInfo& GetUlMuInfo(uint8_t linkId);
+
+    /**
+     * Set the duration of the interval between two consecutive requests for channel
+     * access made by the MultiUserScheduler.
+     *
+     * \param interval the duration of the interval between two consecutive requests
+     *                 for channel access
+     */
+    void SetAccessReqInterval(Time interval);
 
   protected:
     /**
-     * Get the station manager attached to the AP.
+     * Get the station manager attached to the AP on the given link.
+     *
+     * \param linkId the ID of the given link
+     * \return the station manager attached to the AP on the given link
+     */
+    Ptr<WifiRemoteStationManager> GetWifiRemoteStationManager(uint8_t linkId) const;
+
+    /**
+     * Get the HE Frame Exchange Manager attached to the AP on the given link.
      *
-     * \return the station manager attached to the AP
+     * \param linkId the ID of the given link
+     * \return the HE Frame Exchange Manager attached to the AP on the given link
      */
-    Ptr<WifiRemoteStationManager> GetWifiRemoteStationManager() const;
+    Ptr<HeFrameExchangeManager> GetHeFem(uint8_t linkId) const;
 
     /**
      * Get an MPDU containing the given Trigger Frame.
      *
      * \param trigger the given Trigger Frame
+     * \param linkId the ID of the link on which the Trigger Frame has to be sent
      * \return an MPDU containing the given Trigger Frame
      */
-    Ptr<WifiMpdu> GetTriggerFrame(const CtrlTriggerHeader& trigger) const;
+    Ptr<WifiMpdu> GetTriggerFrame(const CtrlTriggerHeader& trigger, uint8_t linkId) const;
 
     /**
-     * Get the format of the last transmission, as determined by the last call
-     * to NotifyAccessGranted that did not return NO_TX.
+     * Get the format of the last transmission on the given link, as determined by
+     * the last call to NotifyAccessGranted that did not return NO_TX.
      *
-     * \return the format of the last transmission
+     * \param linkId the ID of the given link
+     * \return the format of the last transmission on the given link
      */
-    TxFormat GetLastTxFormat() const;
+    TxFormat GetLastTxFormat(uint8_t linkId);
 
     /**
      * Get the maximum size in bytes among the A-MPDUs containing QoS Null frames
@@ -158,12 +182,12 @@
     void NotifyNewAggregate() override;
     void DoInitialize() override;
 
-    Ptr<ApWifiMac> m_apMac;              //!< the AP wifi MAC
-    Ptr<HeFrameExchangeManager> m_heFem; //!< HE Frame Exchange Manager
-    Ptr<QosTxop> m_edca;                 //!< the AC that gained channel access
-    Time m_availableTime;                //!< the time available for frame exchange
-    bool m_initialFrame;                 //!< true if a TXOP is being started
-    uint16_t m_allowedWidth;             //!< the allowed width in MHz for the current transmission
+    Ptr<ApWifiMac> m_apMac;  //!< the AP wifi MAC
+    Ptr<QosTxop> m_edca;     //!< the AC that gained channel access
+    Time m_availableTime;    //!< the time available for frame exchange
+    bool m_initialFrame;     //!< true if a TXOP is being started
+    uint16_t m_allowedWidth; //!< the allowed width in MHz for the current transmission
+    uint8_t m_linkId;        //!< the ID of the link over which channel access has been granted
 
   private:
     /**
@@ -208,14 +232,22 @@
      */
     void CheckTriggerFrame();
 
-    TxFormat m_lastTxFormat{NO_TX}; ///< the format of last transmission
-    DlMuInfo m_dlInfo;              ///< information required to perform a DL MU transmission
-    UlMuInfo m_ulInfo;              ///< information required to solicit an UL MU transmission
-    EventId m_accessReqTimer;       ///< the timer controlling additional channel access requests
-    Time m_accessReqInterval;       ///< duration of the interval between channel access requests
-    AcIndex m_accessReqAc;          ///< AC we request channel access for
-    bool m_restartTimerUponAccess;  ///< whether the channel access timer has to be restarted
-                                    ///< upon channel access
+    /**
+     * Type for the information about the last transmission
+     */
+    struct LastTxInfo
+    {
+        TxFormat lastTxFormat{NO_TX}; ///< the format of last transmission
+        DlMuInfo dlInfo;              ///< information required to perform a DL MU transmission
+        UlMuInfo ulInfo;              ///< information required to solicit an UL MU transmission
+    };
+
+    std::map<uint8_t, LastTxInfo> m_lastTxInfo; ///< Information about the last transmission
+    EventId m_accessReqTimer;      ///< the timer controlling additional channel access requests
+    Time m_accessReqInterval;      ///< duration of the interval between channel access requests
+    AcIndex m_accessReqAc;         ///< AC we request channel access for
+    bool m_restartTimerUponAccess; ///< whether the channel access timer has to be restarted
+                                   ///< upon channel access
 };
 
 } // namespace ns3
